/*   This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; version 2 of the License.
   
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     (C) 2006 schan
*/
#include "gui_skin.h"
#include <fstream>
#include <iostream>

Bitmap GuiSkin::background;
BitmapFont GuiSkin::small_font;
BitmapFont GuiSkin::big_font;
Bitmap GuiSkin::check_on;
Bitmap GuiSkin::check_off;
Bitmap GuiSkin::arrow_up;
Bitmap GuiSkin::arrow_down;
Bitmap GuiSkin::icon_text;
Bitmap GuiSkin::icon_binary;
Bitmap GuiSkin::icon_folder;

std::string GuiSkin::path;

SDL_Color GuiSkin::selected_color = {200,100,50};

void GuiSkin::set_skin(const std::string &name)
{
	GuiSkin::path = "skins/"+name+"/";

	background.unload();

	big_font.close();
	small_font.close();

	check_on.unload();
	check_off.unload();

	arrow_up.unload();
	arrow_down.unload();

	icon_text.unload();
	icon_binary.unload();
	icon_folder.unload();
	
	std::ifstream color_file((GuiSkin::path + "gui_color.cfg").c_str());
	int c_r,c_g,c_b;
	color_file >> c_r;
	color_file >> c_g;
	color_file >> c_b;
	color_file.close();	
	SDL_Color gui_color = {c_r, c_g, c_b};	
	selected_color = gui_color;
	
}

		
		
void GuiSkin::draw_selection(SDL_Surface *s, int x, int y, int w, int h)
{
	SDL_Color c = selected_color;
	
	SDL_Rect r1 = {x, y+2, 1, h-4};
	SDL_FillRect(s,&r1, SDL_MapRGB(s->format,c.r,c.g,c.b));

	SDL_Rect r2 = {x+1, y+1, 1, h-2};
	SDL_FillRect(s,&r2, SDL_MapRGB(s->format,c.r,c.g,c.b));

	SDL_Rect r3 = {x+2, y, w-4, h};
	SDL_FillRect(s,&r3, SDL_MapRGB(s->format,c.r,c.g,c.b));

	SDL_Rect r4 = {x+w-2, y+1, 1, h-2};
	SDL_FillRect(s,&r4, SDL_MapRGB(s->format,c.r,c.g,c.b));

	SDL_Rect r5 = {x+w-1, y+2, 1, h-4};
	SDL_FillRect(s,&r5, SDL_MapRGB(s->format,c.r,c.g,c.b));
}
		
