/*   This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; version 2 of the License.
   
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     (C) 2006 schan
*/
#ifndef GUISKIN_H
#define GUISKIN_H

#include "SDL/SDL.h"
#include "bitmapfont.h"
#include "bitmap.h"
#include "defines.h"


class GuiSkin
{
	public:
	
		static void set_skin(const std::string &name);
	
		static void set_selected_color(SDL_Color c);
		
		static inline Bitmap *get_background()
		{
			if (!background.loaded()) background.load_from_file((path + "bg.bmp").c_str());
			return &background;
		}

		static inline BitmapFont *get_big_font()
		{
			if (!big_font.loaded()) big_font.load((path + "gui_big.bmp").c_str(),CHAR_LIST);
			return &big_font;
		}		
		static inline BitmapFont *get_small_font()
		{
			if (!small_font.loaded()) small_font.load((path + "gui_small.bmp").c_str(),CHAR_LIST_GUI);
			return &small_font; 
		}

		static inline Bitmap *get_check_on()
		{
			if (!check_on.loaded()) check_on.load_from_file((path + "check_on.bmp").c_str());
			return &check_on;
		}
		static inline Bitmap *get_check_off()
		{
			if (!check_off.loaded()) check_off.load_from_file((path + "check_off.bmp").c_str());
			return &check_off;
		}

		static inline Bitmap *get_arrow_up()
		{
			if (!arrow_up.loaded()) arrow_up.load_from_file((path + "arrow_up.bmp").c_str());
			return &arrow_up;
		}
		static inline Bitmap *get_arrow_down()
		{
			if (!arrow_down.loaded()) arrow_down.load_from_file((path + "arrow_down.bmp").c_str());
			return &arrow_down;
		}


		static inline Bitmap *get_icon_text()
		{
			if (!icon_text.loaded()) icon_text.load_from_file((path + "icon_text.bmp").c_str());
			return &icon_text;
		}
		static inline Bitmap *get_icon_binary()
		{
			if (!icon_binary.loaded()) icon_binary.load_from_file((path + "icon_binary.bmp").c_str());
			return &icon_binary;
		}
		static inline Bitmap *get_icon_folder()
		{
			if (!icon_folder.loaded()) icon_folder.load_from_file((path + "icon_folder.bmp").c_str());
			return &icon_folder;
		}



		static inline SDL_Color get_selected_color() { return selected_color; }
				
		static void draw_selection(SDL_Surface *s, int x, int y, int w, int h);
		
	private:
		static std::string path;
		
		static BitmapFont small_font;
		static BitmapFont big_font;
		static SDL_Color selected_color;
		
		static Bitmap background;

		static Bitmap check_on;
		static Bitmap check_off;

		static Bitmap arrow_up;
		static Bitmap arrow_down;

		static Bitmap icon_text;
		static Bitmap icon_binary;
		static Bitmap icon_folder;
};


#endif
