/*   This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; version 2 of the License.
   
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     (C) 2006 schan
*/
#ifndef OPTIONS_H
#define OPTIONS_H

#include <string>

class Options
{
	public:
		Options();
		
		void load();
		void save();
		
		inline bool has_changed() { return changed; }
		
		bool get_justify();
		void set_justify(bool v);
	
		bool get_indent();
		void set_indent(bool v);

		bool get_showstatus();
		void set_showstatus(bool v);
	
		int get_margin();
		void set_margin(int v);
		
		std::string get_font();
		void set_font(const std::string &name);
	
		std::string get_lang();
		void set_lang(const std::string &v);

		std::string get_skin();
		void set_skin(const std::string &v);

	
	private:
		bool changed;
	
		bool opt_justify;
		bool opt_indent;
		bool opt_showstatus;
		int opt_margin;
		std::string opt_font;
		std::string opt_lang;
		std::string opt_skin;
};

#endif
