/*   This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; version 2 of the License.
   
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     (C) 2006 schan
*/
#ifndef STATE_PREFERENCES_H
#define STATE_PREFERENCES_H

#include "engine.h"
#include "bitmap.h"
#include "gui.h"
#include "widget_checkbox.h"
#include "widget_slider.h"

class PreferencesState : public AppState
{

	public:

		~PreferencesState();

		// virtual functions to be overloaded
		void on_init();
		
		void on_button_down(int button);
		void on_button_up(int button);
	
		void think(bool first);
		
		
		// new members
		void redraw();
		
	private:
		Gui *gui;
		
		char text_changed[40];
		char text_unchanged[40];
		
		CheckBoxWidget *widget_justify;
		CheckBoxWidget *widget_indent;
		CheckBoxWidget *widget_showstatus;
		SliderWidget *widget_margin;
		BasicWidget *widget_font;
		BasicWidget *widget_lang;
		BasicWidget *widget_skin;

		void ok(bool save);
		void load();
		
		void fill_gui();
		
};


#endif
