#ifndef TRANSLATION_H
#define TRANSLATION_H


#include <string>



class Translation
{
	public:
		static const int TXT_LANG = 0;
		static const int TXT_OPEN = 1;
		static const int TXT_RECENT = 2;
		static const int TXT_PREFERENCES = 3;
		static const int TXT_EXIT = 4;
		static const int TXT_PREFERENCES_STATUS_CHANGED = 5;
		static const int TXT_PREFERENCES_STATUS_UNCHANGED = 6;
		static const int TXT_MARGIN = 7;
		static const int TXT_JUSTIFY = 8;
		static const int TXT_INDENT = 9;
		static const int TXT_SHOW_STATUS_BAR = 10;
		static const int TXT_CHANGE = 11;
		static const int TXT_SELECT_CANCEL = 12;
		static const int TXT_RECENT_OPEN = 13;
		static const int TXT_LOADING = 14;
		static const int TXT_SELECT = 15;
		static const int TXT_FONT = 16;
		static const int TXT_SELECTOR_STATUS_FILTERED = 17;
		static const int TXT_SELECTOR_STATUS_UNFILTERED = 18;
		static const int TXT_ACTIVATE = 19;
		static const int TXT_DEACTIVATE = 20;
		static const int TXT_GO_UP = 21;
		static const int TXT_NOT_TEXT_FILE = 22;
		static const int TXT_ENCODING = 23;
		static const int TXT_SAMPLE_TEXT = 24;
		static const int TXT_PREVIEW = 25;
		static const int TXT_LANGUAGE = 26;
		static const int TXT_LESS_MORE = 27;
		static const int TXT_PATH = 28;
		static const int TXT_POSITION = 29;
		static const int TXT_SKIN = 30;
		
		
		
		static const int NUM_STRINGS = 31;
		

		static void set_lang(const std::string &l);
		
		static inline int get_num_lang() { return num_lang; }		
		static std::string get_language_name(int id);
		
		static char *get(int id);
		
		
	private:
	
		static int num_lang;
		static bool loaded;
		
		static std::string strings[NUM_STRINGS];
		
		static void replace_special(std::string *str, const std::string& from, const std::string& to);

};


#endif
