/*   This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; version 2 of the License.
   
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     (C) 2006 schan
*/
#include "ttfont.h"
#include <iostream>

TTFont::TTFont()
{
	font = NULL;
	filename = "";
	size = 0;
}

TTFont::~TTFont()
{
	close();
}

		
// inherited from Font
bool TTFont::load(const std::string &filename, int size, SDL_Color fg, SDL_Color bg, bool antialias)
{
	close();

	if (filename=="" || size<=0) return false;
	
	this->fg_color = fg;
	this->bg_color = bg;
	this->size = size;
	this->antialias = antialias;
	
	font = TTF_OpenFont(filename.c_str(), size);
	
	if (!font) {
	    printf("TTF_OpenFont: %s\n", TTF_GetError());
	    // handle error
	}
}

int TTFont::draw_unicode(const Uint16 *text, SDL_Surface *dest, int x, int y,  bool centerH, bool centerV)
{
	int w = get_width_unicode(text);
	int offsetX = 0;
	int offsetY = 0;
	if (centerV) offsetY = -TTF_FontHeight(font)>>1;
	if (centerH) offsetX = -w>>1;
	
	SDL_Rect destRect;					
	destRect.x = x + offsetX;
	int i=0;

	SDL_Surface *temp_surface = TTF_RenderUNICODE_Shaded(font,text,fg_color,bg_color);
	SDL_BlitSurface(temp_surface, NULL, dest, &destRect);
	return temp_surface->w;
	
	
/*	const Uint16 *ch;
	for(ch=text; *ch; ++ch)
	{
		destRect.y = y + offsetY; // restores destRect because SDL_BlitSurface modifies it
		
		temp_surface = TTF_RenderText_Shaded(font, "ab", fg_color, bg_color);
//		SDL_BlitSurface(temp_surface,NULL,dest,&destRect);
//		destRect.x += temp_surface->w;
//		i++;
	}
	
	return w;
	*/

}

int TTFont::draw_unicode(Uint16 unicode_char, SDL_Surface *dest, int x, int y)
{
/*	SDL_Rect destRect;					
	destRect.x = x;
	destRect.y = y;
	destRect.w = clip_rect[unicode_char].w;
	destRect.h = clip_rect[unicode_char].h;
	SDL_BlitSurface(bitmap,&clip_rect[unicode_char],dest,&destRect);
	return destRect.w;
*/
}


int TTFont::draw_text(const char *text, SDL_Surface *dest, int x, int y,  bool centerH, bool centerV)
{
/*	int w = get_width(text);
	int offsetX = 0;
	int offsetY = 0;
	if (centerV) offsetY = -bitmap->h>>1;
	if (centerH) offsetX = -w>>1;
	
	SDL_Rect destRect;					
	destRect.x = x + offsetX;
	int i=0;

	const char *ch;
	for(ch=text; *ch; ++ch)
	{
		destRect.y = y + offsetY; // restores destRect because SDL_BlitSurface modifies it

		SDL_BlitSurface(bitmap,&clip_rect[text[i]],dest,&destRect);
		destRect.x += clip_rect[text[i]].w;
		i++;
	}
	return w;
*/
}

int TTFont::draw_char(char character, SDL_Surface *dest, int x, int y)
{
/*	SDL_Rect destRect;					
	destRect.x = x;
	destRect.y = y;
	destRect.w = clip_rect[character].w;
	destRect.h = clip_rect[character].h;
	SDL_BlitSurface(bitmap,&clip_rect[character],dest,&destRect);
	return destRect.w;
*/
}


int TTFont::draw_utf8(const char *utf8, SDL_Surface *dest, int x, int y,  bool centerH, bool centerV)
{
/*	int w = get_width_utf8(utf8);
	int offsetX = 0;
	int offsetY = 0;
	if (centerV) offsetY = -bitmap->h>>1;
	if (centerH) offsetX = -w>>1;
	
	SDL_Rect destRect;					
	destRect.x = x + offsetX;

	int i, j;
	Uint16 ch;
	for ( i=0, j=0; true; ++i, ++j )
	{
		if (utf8[i]=='\0') break;
		
		ch = ((const unsigned char *)utf8)[i];
		if ( ch >= 0xF0 )
		{
			ch  =  (Uint16)(utf8[i]&0x07) << 18;
			ch |=  (Uint16)(utf8[++i]&0x3F) << 12;
			ch |=  (Uint16)(utf8[++i]&0x3F) << 6;
			ch |=  (Uint16)(utf8[++i]&0x3F);
		}
		else if ( ch >= 0xE0 )
		{
			ch  =  (Uint16)(utf8[i]&0x0F) << 12;
			ch |=  (Uint16)(utf8[++i]&0x3F) << 6;
			ch |=  (Uint16)(utf8[++i]&0x3F);
		}
		else if ( ch >= 0xC0 )
		{
			ch  =  (Uint16)(utf8[i]&0x1F) << 6;
			ch |=  (Uint16)(utf8[++i]&0x3F);
		}


		destRect.y = y + offsetY; // restores destRect because SDL_BlitSurface modifies it
		SDL_BlitSurface(bitmap,&clip_rect[ch],dest,&destRect);
		destRect.x += clip_rect[ch].w;

	}
	
	return w;
*/
}


int TTFont::get_width(const char *text)
{
/*	int i=0;
	int w=0;

	const char *ch;
	for(ch=text; *ch; ++ch)
	{
		w += clip_rect[text[i++]].w;
	}		
	return w;
*/
}

int TTFont::get_width_utf8(const char *utf8)
{
/*	int w = 0;
	int i, j;
	Uint16 ch;
	for ( i=0, j=0; true; ++i, ++j )
	{
		if (utf8[i]=='\0') break;
		
		ch = ((const unsigned char *)utf8)[i];
		if ( ch >= 0xF0 )
		{
			ch  =  (Uint16)(utf8[i]&0x07) << 18;
			ch |=  (Uint16)(utf8[++i]&0x3F) << 12;
			ch |=  (Uint16)(utf8[++i]&0x3F) << 6;
			ch |=  (Uint16)(utf8[++i]&0x3F);
		}
		else if ( ch >= 0xE0 )
		{
			ch  =  (Uint16)(utf8[i]&0x0F) << 12;
			ch |=  (Uint16)(utf8[++i]&0x3F) << 6;
			ch |=  (Uint16)(utf8[++i]&0x3F);
		}
		else if ( ch >= 0xC0 )
		{
			ch  =  (Uint16)(utf8[i]&0x1F) << 6;
			ch |=  (Uint16)(utf8[++i]&0x3F);
		}


		w += clip_rect[ch].w;

	}
	return w;
*/
}

int TTFont::get_width_unicode(const Uint16 *text)
{
/*	int i=0;
	int w=0;

	const Uint16 *ch;
	for(ch=text; *ch; ++ch)
	{
		w += clip_rect[text[i++]].w;
	}		
	return w;
*/
}

int TTFont::get_width_unicode(Uint16 unicode_char)
{
//	return clip_rect[unicode_char].w;
}


int TTFont::get_height()
{
/*	if (bitmap==NULL) return 0;
	else return bitmap->h;*/
}

void TTFont::close()
{
	if (font!=NULL)
	{
		TTF_CloseFont(font);
	}
}

SDL_Color TTFont::get_bg_color()
{
	return bg_color;
}

