/*   This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; version 2 of the License.
   
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     (C) 2006 schan
*/
#ifndef WIDGET_H
#define WIDGET_H

#include "SDL/SDL.h"

class Widget
{
	public:
		virtual ~Widget() {};
		
		virtual int get_height(bool selected) = 0;
		virtual int draw(SDL_Surface *dest, int x, int y, int w, bool selected) = 0;
		// returns widget's height
		
		virtual bool on_button_down(int button) = 0;
		// returns false if button is ignored

		virtual bool on_button_up(int button) = 0;
		// returns false if button is ignored
		
		virtual bool is_selectable() = 0;
		// returns true if widget can be selected
		
};


#endif
