/*   This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; version 2 of the License.
   
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     (C) 2006 schan
*/
#ifndef BASICWIDGET_H
#define BASICWIDGET_H

#include "SDL/SDL.h"
#include "widget.h"
#include "bitmap.h"
#include "bitmapfont.h"
#include <vector>


class BasicWidget : public Widget
{
	public:

		BasicWidget();
		~BasicWidget();

		// inherited
		int draw(SDL_Surface *dest, int x, int y, int w, bool selected);
		int get_height(bool selected);
		bool is_selectable();

		virtual bool on_button_down(int button) { return false; };
		virtual bool on_button_up(int button) { return false; };

		// new members

		/*
		 * draw_custom()
		 * virtual function for drawing extra content
		 * beetwen text1 and text2.
		 * Returns: height of the extra content
		 */
		virtual void draw_custom_content(SDL_Surface *dest, int x, int y, int w, bool selected) { }
		virtual int get_custom_content_height(bool selected) { return 0; }
		
		
		inline void set_text1(Uint16 *new_text, bool _delete)
		{
			if (text1!=NULL && delete_text1)
			{
				delete []text1;
			}
			text1 = new_text;
			delete_text1 = _delete;
		}
		inline void set_text2(Uint16 *new_text, bool _delete)
		{
			if (text2!=NULL && delete_text2)
			{
				delete []text2;
			}
			text2 = new_text;
			delete_text2 = _delete;
		}
		inline void set_icon(Bitmap *b, bool _delete)
		{
			if (delete_icon)
			{
				delete icon;
			}
			icon  = b;
			delete_icon = _delete;

		}
		inline void set_selectable(bool s)
		{
			selectable = s;
		}
			
	private:
		Uint16 *text1;
		Uint16 *text2;
		Bitmap *icon;
		bool selectable;
		
		bool delete_text1;
		bool delete_text2;
		bool delete_icon;



};


#endif
