/*   This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; version 2 of the License.
   
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     (C) 2006 schan
*/
#include "defines.h"
#include "gui_skin.h"
#include "widget_checkbox.h"
#include "bitmapfont.h"
#include "util.h"
#include "translation.h"
#include <vector>

Uint16 *CheckBoxWidget::hint_on = util::utf8_to_unicode(Translation::get(Translation::TXT_DEACTIVATE));
Uint16 *CheckBoxWidget::hint_off = util::utf8_to_unicode(Translation::get(Translation::TXT_ACTIVATE));

CheckBoxWidget::CheckBoxWidget(Uint16 *text)
{
	set_text1(text,true);
	set_checked(false);
}

CheckBoxWidget::~CheckBoxWidget()
{
}

void CheckBoxWidget::set_checked(bool c)
{
	checked = c;	
	set_text2(checked ? hint_on : hint_off, false);
	set_icon(checked ? GuiSkin::get_check_on() : GuiSkin::get_check_off(), false);
}

bool CheckBoxWidget::on_button_down(int button)
{
	if (button==GP2X_BUTTON_B)
	{
		set_checked(!is_checked());
		return true;
	}
	else return false;
}

//////////////////////////

void CheckBoxWidget::refresh_lang()
{
	delete []hint_on;
	delete []hint_off;
	CheckBoxWidget::hint_on = util::utf8_to_unicode(Translation::get(Translation::TXT_DEACTIVATE));
	CheckBoxWidget::hint_off = util::utf8_to_unicode(Translation::get(Translation::TXT_ACTIVATE));
}
