/*   This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; version 2 of the License.
   
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     (C) 2006 schan
*/
#include "defines.h"
#include "gui_skin.h"
#include "widget_slider.h"
#include "bitmapfont.h"
#include "util.h"
#include "translation.h"
#include <vector>


SliderWidget::SliderWidget(const std::string &text, int min, int max)
{
	this->text = text;
	this->min = min;
	this->max = max;
	set_value(min);

	set_text2(util::utf8_to_unicode(Translation::get(Translation::TXT_LESS_MORE)),true);

}

SliderWidget::~SliderWidget()
{
}

void SliderWidget::set_value(int v)
{
	value = v;
	if (value<min) value = min;
	if (value>max) value = max;

	sprintf(final_text,"%s: %d",text.c_str(),value);
	set_text1(util::utf8_to_unicode(final_text),true);
}

bool SliderWidget::on_button_down(int button)
{
	if (button==GP2X_BUTTON_L)
	{
		inc_value(-1);
		return true;
	}
	else if (button==GP2X_BUTTON_R)
	{
		inc_value(1);
		return true;
	}
	else return false;
}
